
/* This file is created by the "tcl2c" utility, which is included in
 * most "plus"-patches (e.g. for Tcl7.6 and Tcl8.0). Standalone
 * executables can be made by providing alternative initialization
 * functions which don't read files any more. Sometimes, small
 * adaptations to the original libraries are needed to get the
 * application truly standalone. The "plus"-patches contain these
 * adaptations for Tcl and Tk. If you just create your own
 * Xxx_InitStandAlone() function for your package, you can
 * easyly extend the "tcl2c" utility to your own requirements.
 *
 *	Jan Nijtmans
 *	NICI (Nijmegen Institute of Cognition and Information)
 *	email: nijtmans@nici.kun.nl
 *	url:   http://www.cogsci.kun.nl/~nijtmans/
 */
#include "tcl.h"

/*
 * Defines to replace the standard Xxx_Init calls to Xxx_InitStandAlone.
 * If you don't have this function, just delete the corresponding
 * define such that the normal initialization function is used.
 * Similar: If SafeInit functions exists, you can use these
 * by commenting out the corresponding lines below.
 */

#ifdef TCL_ACTIVE
#define Tcl_Init Tcl_InitStandAlone
#define Tk_Init Tk_InitStandAlone
#endif

#define Tcl_SafeInit (Tcl_PackageInitProc *) NULL
#define Tk_SafeInit (Tcl_PackageInitProc *) NULL

/*
 * Prototypes of all initialization functions and the free() function.
 * So, only "tcl.h" needs to be included now.
 */

#ifdef __cplusplus
extern "C" {
#endif

extern void free _ANSI_ARGS_((void *));
extern int  Tcl_Init _ANSI_ARGS_((Tcl_Interp *interp));
#ifndef Tcl_SafeInit
extern int  Tcl_SafeInit _ANSI_ARGS_((Tcl_Interp *interp));
#endif
extern int  Tk_Init _ANSI_ARGS_((Tcl_Interp *interp));
#ifndef Tk_SafeInit
extern int  Tk_SafeInit _ANSI_ARGS_((Tcl_Interp *interp));
#endif

#ifdef __cplusplus
}
#endif

/*
 * The array "script" contains the script that is compiled in.
 * It will be executed in tclAppInit() after the other initializations.
 */

static int line = (__LINE__ + 1);
static char *script[] = {
"load libRootwin0.4.so",
"load libXop0.4.so",
"load libForeignwin0.1.so",
"wm withdraw .",
"update idletasks",
"rootwin .rw -background #1f54ac",
"array set WinInfo {}",
"variable WindowMarkPos",
"variable WindowMarkSize",
"variable WindowNumber 0",
"image create bitmap closeImage -data {\n\
 #define close_width 18\n\
 #define close_height 17\n\
 static unsigned char close_bits[] = {\n\
   0xfe, 0xff, 0x01, 0xfe, 0xff, 0x01, 0x06, 0x80, 0x01, 0x06, 0x80, 0x01,\n\
   0x06, 0x80, 0x01, 0x06, 0x80, 0x01, 0x86, 0x87, 0x01, 0x86, 0x87, 0x01,\n\
   0x86, 0x87, 0x01, 0x86, 0x87, 0x01, 0x06, 0x80, 0x01, 0x06, 0x80, 0x01,\n\
   0x06, 0x80, 0x01, 0x06, 0x80, 0x01, 0xfe, 0xff, 0x01, 0xfe, 0xff, 0x01,\n\
   0x00, 0x00, 0x00 };\n\
}",
"image create bitmap maxImage -data {\n\
 #define max_width 21\n\
 #define max_height 17\n\
 static unsigned char max_bits[] = {\n\
   0xf0, 0xff, 0x0f, 0xf0, 0xff, 0x0f, 0xf0, 0x0f, 0x0c, 0xf0, 0x0f, 0x0c,\n\
   0xf0, 0x0f, 0x0c, 0xf0, 0x0f, 0x0c, 0xf0, 0x0f, 0x0c, 0xf0, 0x0f, 0x0c,\n\
   0x30, 0x00, 0x0c, 0x30, 0x00, 0x0c, 0x30, 0x00, 0x0c, 0x30, 0x00, 0x0c,\n\
   0x30, 0x00, 0x0c, 0x30, 0x00, 0x0c, 0xf0, 0xff, 0x0f, 0xf0, 0xff, 0x0f,\n\
   0x00, 0x00, 0x00 };\n\
}",
"image create bitmap lowerImage -data {\n\
 #define lower_width 18\n\
 #define lower_height 17\n\
 static unsigned char lower_bits[] = {\n\
   0xfe, 0x1f, 0x00, 0xfe, 0x1f, 0x00, 0x06, 0x18, 0x00, 0x06, 0x18, 0x00,\n\
   0x06, 0x18, 0x00, 0xc6, 0xff, 0x01, 0xc6, 0xff, 0x01, 0xc6, 0xff, 0x01,\n\
   0xc6, 0xff, 0x01, 0xc6, 0xff, 0x01, 0xc6, 0xff, 0x01, 0xc6, 0xff, 0x01,\n\
   0xfe, 0xff, 0x01, 0xfe, 0xff, 0x01, 0xc0, 0xff, 0x01, 0xc0, 0xff, 0x01,\n\
   0x00, 0x00, 0x00 };\n\
}",
"image create bitmap raiseImage -data {\n\
 #define raise_width 18\n\
 #define raise_height 17\n\
 static unsigned char raise_bits[] = {\n\
   0xfe, 0x1f, 0x00, 0xfe, 0x1f, 0x00, 0xfe, 0xff, 0x01, 0xfe, 0xff, 0x01,\n\
   0x7e, 0x80, 0x01, 0x7e, 0x80, 0x01, 0x7e, 0x80, 0x01, 0x7e, 0x80, 0x01,\n\
   0x7e, 0x80, 0x01, 0x7e, 0x80, 0x01, 0x7e, 0x80, 0x01, 0x7e, 0x80, 0x01,\n\
   0x60, 0x80, 0x01, 0x60, 0x80, 0x01, 0xe0, 0xff, 0x01, 0xe0, 0xff, 0x01,\n\
   0x00, 0x00, 0x00 };\n\
}",
"image create bitmap resizeImage -data {\n\
 #define resize_width 13\n\
 #define resize_height 15\n\
 static unsigned char resize_bits[] = {\n\
   0x3f, 0x00, 0x3f, 0x00, 0x33, 0x00, 0x33, 0x00, 0xff, 0x0f, 0xff, 0x0f,\n\
   0x30, 0x0c, 0x30, 0x0c, 0x30, 0x0c, 0x30, 0x0c, 0x30, 0x0c, 0x30, 0x0c,\n\
   0xf0, 0x0f, 0xf0, 0x0f, 0x00, 0x00 };\n\
}",
"frame .rw.topbar -padx 6 -height 20 -background #fcfffb",
"menu .rw.tasks -borderwidth 2 -activeborderwidth 0 -relief flat -background #fcfffb -foreground #1f54ac -activebackground black -activeforeground #ff8a00 -tearoff 0",
"bind .rw <ButtonPress-3> {\n\
	if {%i == [winfo id .rw] || %i == [winfo id .rw.topbar]} {\n\
		tk_popup .rw.tasks %x %y\n\
	}\n\
}	",
"proc Run {} {\n\
	variable to_run {}\n\
	set run {\n\
		catch {exec {*}$to_run &}\n\
		wm withdraw .rw.run\n\
	}\n\
\n\
	if {![winfo exists .rw.run]} {\n\
		toplevel .rw.run\n\
		wm geometry .rw.run +90+50\n\
		entry .rw.run.form -borderwidth 0 -highlightthickness 2 -highlightcolor #fcfffb -insertbackground #ff8a00 -background #1f54ac -foreground #fcfffb -selectbackground black -selectforeground #ff8a00 -width 60 -font {-size 9 -weight bold} -textvariable to_run\n\
		bind .rw.run.form <Return> $run\n\
		bind .rw.run.form <FocusOut> {wm withdraw .rw.run}\n\
		\n\
		pack .rw.run.form\n\
	}\n\
	\n\
	wm deiconify .rw.run\n\
	raise .rw.run\n\
	focus -force .rw.run.form\n\
}",
"proc About {} {\n\
	if {![winfo exists .rw.about]} {\n\
		frame .rw.about -background #fcfffb\n\
		frame .rw.about.into -pady 3 -background #1f54ac\n\
		frame .rw.about.into.main -background #fcfffb\n\
		frame .rw.about.into.main.border -background #1f54ac\n\
		label .rw.about.into.main.border.message -background #fcfffb -foreground black -font {-size 9 -weight bold} -text \"RetroLook 20160626\\nCopyright (C) 2016 Pasquale Frega\\nAll rights reserved\\n\\nBased on TKWM 2.0\\nby Neil McKay\\nand Peter MacDonald\"\n\
		frame .rw.about.into.button -background #ff8a00\n\
		button .rw.about.into.button.ok -borderwidth 0 -background #fcfffb -activebackground #fcfffb -highlightbackground #fcfffb -foreground black -font {-size 9 -weight bold} -text {Ok} -command {place forget .rw.about}\n\
		\n\
		pack .rw.about.into.main.border.message -padx 2 -pady 2 -ipadx 19 -ipady 19\n\
		pack .rw.about.into.main.border -padx 2 -pady 2\n\
		pack .rw.about.into.main -padx 6 -pady 2\n\
		pack .rw.about.into.button.ok -padx 2 -pady 2\n\
		pack .rw.about.into.button -pady 2\n\
		pack .rw.about.into -padx 2 -pady 2\n\
	}\n\
\n\
	place .rw.about -x 0 -y 0\n\
	raise .rw.about\n\
}",
"proc Quit {} {\n\
	if {![winfo exists .rw.quit]} {\n\
		frame .rw.quit -background #fcfffb\n\
		frame .rw.quit.into -pady 3 -background #1f54ac\n\
		frame .rw.quit.into.main -background #fcfffb\n\
		frame .rw.quit.into.main.border -background #1f54ac\n\
		label .rw.quit.into.main.border.message -background #fcfffb -foreground black -font {-size 9 -weight bold} -text \"Do you really want\\nto quit workbench?\"\n\
		frame .rw.quit.into.buttons -background #1f54ac\n\
		button .rw.quit.into.buttons.ok -borderwidth 0 -background #fcfffb -activebackground #fcfffb -highlightthickness 2 -highlightbackground #ff8a00 -foreground black -font {-size 9 -weight bold} -text {Ok} -command exit\n\
		button .rw.quit.into.buttons.cancel -borderwidth 0 -background #fcfffb -activebackground #fcfffb -highlightthickness 2 -highlightbackground #ff8a00 -foreground black -font {-size 9 -weight bold} -text {Cancel} -command {place forget .rw.quit}\n\
	\n\
		pack .rw.quit.into.main.border.message -padx 2 -pady 2 -ipadx 19 -ipady 19\n\
		pack .rw.quit.into.main.border -padx 2 -pady 2\n\
		pack .rw.quit.into.main -padx 6 -pady 2\n\
		pack .rw.quit.into.buttons.ok -padx 6 -ipady 1 -side left\n\
		pack .rw.quit.into.buttons.cancel -padx 6 -ipady 1 -side right\n\
		pack .rw.quit.into.buttons -pady 2 -expand true -fill both\n\
		pack .rw.quit.into -padx 2 -pady 2\n\
	}\n\
	\n\
	place .rw.quit -x 0 -y 0\n\
	raise .rw.quit\n\
}",
"if {[file exists ~/.retrolookmenu]} {\n\
	if {![catch {open ~/.retrolookmenu} chid]} {\n\
		menubutton .rw.topbar.workbench -borderwidth 0 -background #fcfffb -foreground #1f54ac -activebackground black -activeforeground #ff8a00 -font {-size 9 -weight bold} -text {Workbench} -menu .rw.topbar.workbench.menu\n\
		menu .rw.topbar.workbench.menu -borderwidth 2 -activeborderwidth 0 -relief flat -background #fcfffb -foreground #1f54ac -activebackground black -activeforeground #ff8a00 -tearoff 0\n\
		while {![string equal [set got_string [gets $chid]] {}]} {\n\
			.rw.topbar.workbench.menu add command -font {-size 9 -weight bold} -label [lindex $got_string 0] -command \"catch {exec [lindex $got_string 1] &}\"\n\
		}\n\
		close $chid\n\
		.rw.topbar.workbench.menu add separator\n\
		.rw.topbar.workbench.menu add command -font {-size 9 -weight bold} -label {Run...} -command Run\n\
		.rw.topbar.workbench.menu add command -font {-size 9 -weight bold} -label {About} -command About\n\
		.rw.topbar.workbench.menu add command -font {-size 9 -weight bold} -label {Quit} -command Quit\n\
	} else {\n\
		tk_messageBox -icon error -message {ERROR}\n\
		exit 1\n\
	}\n\
} else {\n\
	tk_messageBox -icon warning -message {Need ~/.retrolookmenu}\n\
	exit 1\n\
}",
"button .rw.topbar.lowerbutton -borderwidth 0 -highlightthickness 0 -background #fcfffb -activebackground #fcfffb -image lowerImage -command {lower .rw.topbar}",
"button .rw.topbar.raisebutton -borderwidth 0 -highlightthickness 0 -background #fcfffb -activebackground #fcfffb -image raiseImage -command {raise .rw.topbar}",
"pack propagate .rw.topbar false",
"pack .rw.topbar.workbench -padx 20 -side left",
"pack .rw.topbar.raisebutton -pady {1 0} -side right",
"pack .rw.topbar.lowerbutton -pady {1 0} -padx 2 -side right",
"pack .rw.topbar -fill x",
"if {![catch {package require img::xpm}]} {\n\
	image create photo ramdisk -data {/* XPM */\n\
static char * ramdisk_xpm[] = {\n\
\"32 32 4 1\",\n\
\"       c #000021\",\n\
\".      c #0055AD\",\n\
\"+      c #FFFFFF\",\n\
\"@      c #FF8A00\",\n\
\"                          ......\",\n\
\"                          ......\",\n\
\"  ++++++@@@@@@    @@@@++    ....\",\n\
\"  ++++++@@@@@@    @@@@++    ....\",\n\
\"  ++++++@@@@@@    @@@@++++    ..\",\n\
\"  ++++++@@@@@@    @@@@++++    ..\",\n\
\"  ++++++@@@@@@    @@@@++++++    \",\n\
\"  ++++++@@@@@@    @@@@++++++    \",\n\
\"  ++++++@@@@@@    @@@@++++++++  \",\n\
\"  ++++++@@@@@@    @@@@++++++++  \",\n\
\"  ++++++@@@@@@@@@@@@@@++++++++  \",\n\
\"  ++++++@@@@@@@@@@@@@@++++++++  \",\n\
\"  ++++++++++++++++++++++++++++  \",\n\
\"  ++++++++++++++++++++++++++++  \",\n\
\"  ++++++++++++++++++++++++++++  \",\n\
\"  ++++++++++++++++++++++++++++  \",\n\
\"  ++++++++++++++++++++++++++++  \",\n\
\"  ++++++++++++++++++++++++++++  \",\n\
\"  ++++++++++++++++++++++++++++  \",\n\
\"  ++++++++++++++++++++++++++++  \",\n\
\"  ++++++++++++++++++++++++++++  \",\n\
\"  ++++++++++++++++++++++++++++  \",\n\
\"  ++++++++++++++++++++++++++++  \",\n\
\"  ++++++++++++++++++++++++++++  \",\n\
\"  ++++++++++++++++++++++++++++  \",\n\
\"  ++++++++++++++++++++++++++++  \",\n\
\"  ++++++++++++++++++++++++++++  \",\n\
\"  ++++++++++++++++++++++++++++  \",\n\
\"  ++++++++++++++++++++++++++++  \",\n\
\"  ++++++++++++++++++++++++++++  \",\n\
\"                                \",\n\
\"                                \"};\n\
	}\n\
	image create photo workbench -data {/* XPM */\n\
static char * workbench_xpm[] = {\n\
\"35 30 5 1\",\n\
\"       c #000021\",\n\
\".      c #FF8A00\",\n\
\"+      c #0055AD\",\n\
\"@      c #FFFFFF\",\n\
\"#      c #000000\",\n\
\"         .................       ++\",\n\
\"         .................       ++\",\n\
\"         ..........    ...        +\",\n\
\"         ..........    ...        +\",\n\
\"         ..........    ...         \",\n\
\"         ..........    ...         \",\n\
\"         ..........    ...         \",\n\
\"         ..........    ...         \",\n\
\"         .................         \",\n\
\"         .................         \",\n\
\"                                   \",\n\
\"                                   \",\n\
\"                                   \",\n\
\"                                   \",\n\
\"      @@@@@@@@@@@@@@@@@@@@@@       \",\n\
\"      @@@@@@@@@@@@@@@@@@@@@@       \",\n\
\"      @@@@@@@@@@@@@@@@@@@@@@@      \",\n\
\"      @@@@@@@@@@@@@@@@@@@@@@@      \",\n\
\"      @@@@@@@@@@@@@@@@@@@@@@@      \",\n\
\"      @#@#@@@#@#@@@#@#@@@#@#@      \",\n\
\"      @@#@#@@@#@#@#@#@@@#@#@@      \",\n\
\"      @@@#@#@@@#@#@#@@@#@#@@@      \",\n\
\"      @@@@#@#@@@#@#@@@#@#@@@@      \",\n\
\"      @@@@@#@#@#@#@#@#@#@@@@@      \",\n\
\"      @@@@@@#@#@#@#@#@#@@@@@@      \",\n\
\"      @@@@@@@#@#@@@#@#@@@@@@@      \",\n\
\"  ++  @@@@@@@@@@@@@@@@@@@@@@@      \",\n\
\"  ++  @@@@@@@@@@@@@@@@@@@@@@@      \",\n\
\"      @@@@@@@@@@@@@@@@@@@@@@@      \",\n\
\"      @@@@@@@@@@@@@@@@@@@@@@@      \"};\n\
	}\n\
\n\
	label .rw.ramdisk -borderwidth 0 -background #1f54ac -foreground #fcfffb -image ramdisk -compound top -font {-size 9 -weight bold} -text {RAM DISK}\n\
	label .rw.workbench -borderwidth 0 -background #1f54ac -foreground #fcfffb -image workbench -compound top -font {-size 9 -weight bold} -text {Workbench1.4}\n\
\n\
	place .rw.ramdisk -x 17 -y 33\n\
	place .rw.workbench -x 0 -y 89\n\
}",
"proc CleanupFor {XId WindowNumber} {\n\
	global WinInfo\n\
\n\
	foreach idx [array names WinInfo \"$XId,*\"] {\n\
		unset WinInfo($idx)\n\
	}\n\
	for {set idx 0} {$idx <= $WindowNumber} {incr idx} {\n\
		if {[.rw.tasks entrycget $idx -value] == $WindowNumber} {\n\
			.rw.tasks delete $idx\n\
			break\n\
		}\n\
	} \n\
}",
"    	",
"proc CloseWindow {XId wf} {\n\
	xop event send $XId ClientMessage -messagetype [winfo atom WM_PROTOCOLS] -format 32 -data \"[winfo atom WM_DELETE_WINDOW] 0\"\n\
	destroy $wf.center.fw\n\
}",
"proc CheckMapState {XId wf} {\n\
	catch {array set atts [xop window $XId attributes]}\n\
	\n\
	if {[info exists atts(mapInstalled)] && $atts(mapInstalled) && [info exists atts(mapState)] && [string equal $atts(mapState) {unmapped}]} {\n\
		destroy $wf.center.fw\n\
	}\n\
}",
"proc MarkAndRaise {w XId x y} {\n\
    	global WindowMarkPos\n\
\n\
    	raise $w\n\
    	set WindowMarkPos($w,x) $x\n\
    	set WindowMarkPos($w,y) $y\n\
	\n\
	xop focus \"$XId None\"\n\
}",
"proc Move {w XId x y} {\n\
    	global WindowMarkPos\n\
    	global WinInfo\n\
\n\
	if {$WinInfo($XId,Max) == 0} {\n\
		set offsetX [expr {$x - $WindowMarkPos($w,x) + $WinInfo($XId,XPos)}]\n\
    		set offsetY [expr {$y - $WindowMarkPos($w,y) + $WinInfo($XId,YPos)}]\n\
    		place $w -x $offsetX -y $offsetY\n\
\n\
    		set WinInfo($XId,XPos) $offsetX\n\
    		set WinInfo($XId,YPos) $offsetY\n\
\n\
    		set WindowMarkPos($w,x) $x\n\
    		set WindowMarkPos($w,y) $y\n\
    	}\n\
}",
"proc MaxMinWindow {XId} {\n\
    	global WinInfo\n\
\n\
	set w $WinInfo($XId,Path)\n\
    	if {$WinInfo($XId,Max)} {\n\
	\n\
		;# Restore original window size.\n\
\n\
		$w.center.fw configure -width $WinInfo($XId,NWidth) -height $WinInfo($XId,NHeight)\n\
		place $w -x $WinInfo($XId,XPos) -y $WinInfo($XId,YPos)\n\
		set WinInfo($XId,Max) 0\n\
    \n\
    	} else {\n\
	\n\
		;# Maximize window. First, figure out how big it should be.\n\
\n\
		set widthDiff [expr {[winfo width $w] - [winfo width $w.center.fw]}]\n\
		set heightDiff [expr {[winfo height $w] - [winfo height $w.center.fw]}]\n\
		set maxWidth [expr {[winfo width .rw] - $widthDiff}]\n\
		set maxHeight [expr {[winfo height .rw] - $heightDiff - 20}]\n\
\n\
		;# Now resize the window, and put it in the upper left corner.\n\
\n\
		$w.center.fw configure -width $maxWidth -height $maxHeight\n\
		place $w -x 0 -y 20\n\
		set WinInfo($XId,Max) 1\n\
    	\n\
    	}\n\
}",
"proc MarkSpot {w XId x y} {\n\
	global WindowMarkPos\n\
    	global WindowMarkSize\n\
\n\
    	set WindowMarkPos($w,X) $x\n\
    	set WindowMarkPos($w,Y) $y\n\
    	set WindowMarkSize($w,Width) [winfo width $w.center.fw]\n\
    	set WindowMarkSize($w,Height) [winfo height $w.center.fw]\n\
}",
"proc ResizeWin {w XId xSizeMult x xOffsetMult ySizeMult y yOffsetMult} {\n\
    	global WinInfo\n\
    	global WindowMarkPos\n\
    	global WindowMarkSize\n\
\n\
    	set deltaX [expr {$x - $WindowMarkPos($w,X)}]\n\
    	set deltaY [expr {$y - $WindowMarkPos($w,Y)}]\n\
\n\
    	set NewWindowWidth [expr {$WindowMarkSize($w,Width) + $xSizeMult*$deltaX}]\n\
    	set NewWindowHeight [expr {$WindowMarkSize($w,Height) + $ySizeMult*$deltaY}]\n\
    	$w.center.fw configure -width $NewWindowWidth -height $NewWindowHeight\n\
    	if {!$WinInfo($XId,Max)} {\n\
		set WinInfo($XId,NWidth) $NewWindowWidth\n\
		set WinInfo($XId,NHeight) $NewWindowHeight\n\
    	}\n\
}",
"proc MakeFrameAround {XId} {\n\
	global WinInfo\n\
	global WindowNumber\n\
	variable Title {X}\n\
    	\n\
	;# Make sure we don't do this twice.\n\
\n\
    	if {[info exists WinInfo($XId,Path)]} {\n\
    		return\n\
    	}\n\
    	\n\
    	;# Try to get informations about the window.\n\
\n\
	array set atts [xop window $XId attributes]\n\
	catch {set Title [xop wmprops $XId name]}\n\
	catch {array set normalhints [xop wmprops $XId normalhints]}\n\
\n\
    	;# Make a frame in the root window to hold the managed window.\n\
\n\
    	set wf \".rw.frame$WindowNumber\"\n\
    	frame $wf -background #fcfffb\n\
    	set WinInfo($XId,Path) $wf\n\
\n\
    	;# Make the title bar at the top.\n\
\n\
    	frame $wf.top -height 20 -background #fcfffb\n\
    	button $wf.top.closebutton -borderwidth 0 -highlightthickness 0 -background #fcfffb -activebackground #fcfffb -image closeImage -command [list CloseWindow $XId $wf]\n\
    	label  $wf.top.title -background #fcfffb -foreground #1f54ac -font {-size 9 -weight bold} -text $Title\n\
    	frame $wf.top.bluerows -background #1f54ac\n\
    	frame $wf.top.bluerows.into -background #fcfffb\n\
    	button $wf.top.maxbutton -borderwidth 0 -highlightthickness 0 -background #fcfffb -activebackground #fcfffb -image maxImage -command [list MaxMinWindow $XId]\n\
    	button $wf.top.lowerbutton -borderwidth 0 -highlightthickness 0 -background #fcfffb -activebackground #fcfffb -image lowerImage -command \"catch {lower $wf; lower .rw.ramdisk; lower .rw.workbench}\"\n\
    	button $wf.top.raisebutton -borderwidth 0 -highlightthickness 0 -background #fcfffb -activebackground #fcfffb -image raiseImage -command [list MarkAndRaise $wf $XId %X %Y]\n\
\n\
	;# Make the center frame.\n\
	\n\
	frame $wf.center -background #fcfffb\n\
\n\
    	;# Get window width/height and create the application frame.\n\
\n\
	set winWidth 1\n\
	set winHeight 1\n\
	catch {set winWidth [lindex $atts(size) 0]}\n\
	catch {set winHeight [lindex $atts(size) 1]}\n\
    	if {[info exists normalhints(userSize)]} {\n\
		set winWidth [lindex $normalhints(userSize) 0]\n\
		set winHeight [lindex $normalhints(userSize) 1]\n\
	} elseif {[info exists normalhints(progSize)]} {\n\
		set winWidth [lindex $normalhints(progSize) 0]\n\
		set winHeight [lindex $normalhints(progSize) 1]\n\
    	} else {\n\
    		if {$winWidth == 1} {\n\
			set winWidth 512\n\
		}\n\
		if {$winHeight == 1} {\n\
			set winHeight 384\n\
		}\n\
    	}\n\
    	set WinInfo($XId,NWidth) $winWidth\n\
    	set WinInfo($XId,NHeight) $winHeight\n\
    	if {[catch {foreignwin $wf.center.fw $XId -width $winWidth -height $winHeight} FW]} {\n\
		return\n\
    	}\n\
	\n\
	;# Make the right bar and the resize button.\n\
	\n\
	frame $wf.center.rightbar -background #fcfffb\n\
	frame $wf.center.rightbar.bluecolumns -background #1f54ac\n\
	frame $wf.center.rightbar.bluecolumns.into -background #fcfffb\n\
	button $wf.center.rightbar.resizebutton -borderwidth 0 -highlightthickness 0 -background #fcfffb -activebackground #fcfffb -image resizeImage\n\
\n\
	;# Add item into the active tasks menu'.\n\
	\n\
	.rw.tasks add radiobutton -indicatoron false -font {-size 9 -weight bold} -label [string range $Title 0 19] -command \"$wf.top.raisebutton invoke\" -value $WindowNumber\n\
	\n\
    	;# Bind stuff so that we can move/resize/etc...\n\
\n\
	bind $wf <Map> \"tkwait visibility $wf.center.fw; $wf.top.raisebutton invoke\"\n\
	foreach topwidget [list $wf.top $wf.top.title $wf.top.bluerows $wf.top.bluerows.into] {\n\
		bind $topwidget <ButtonPress-1> [list MarkAndRaise $wf $XId %X %Y]\n\
		bind $topwidget <Button1-Motion> [list catch [list Move $wf $XId %X %Y]]\n\
	}\n\
	foreach rightwidget [list $wf.center.rightbar $wf.center.rightbar.bluecolumns $wf.center.rightbar.bluecolumns.into] {\n\
		bind $rightwidget <ButtonPress-1> [list MarkAndRaise $wf $XId %X %Y]\n\
	}\n\
	bind $wf.center.rightbar.resizebutton <ButtonPress-1> [list MarkSpot $wf $XId %X %Y]\n\
	bind $wf.center.rightbar.resizebutton <Button1-Motion> [list ResizeWin $wf $XId 1 %X 0 1 %Y 0]\n\
    	bind $wf <Enter> [list catch [list xop focus \"$XId None\"]]\n\
	bind $FW <Expose> [list CheckMapState $XId $wf]\n\
	\n\
	;# We always forget the window frame and never destroy it.\n\
	;# Why? Because it crashes!\n\
	\n\
	bind $FW <Destroy> \"place forget $wf; CleanupFor $XId $WindowNumber\"\n\
\n\
	;# Pack everything.\n\
	\n\
	pack propagate $wf.top false\n\
	pack $wf.top.closebutton -padx 2 -pady {1 0} -side left\n\
	pack $wf.top.title -padx 1 -side left\n\
	pack $wf.top.bluerows.into -pady 4 -fill both -expand true\n\
	pack $wf.top.bluerows -padx 1 -pady 4 -side left -fill both -expand true\n\
	pack $wf.top.maxbutton -padx 2 -pady {1 0} -side left\n\
	pack $wf.top.lowerbutton -pady {1 0} -side left\n\
	pack $wf.top.raisebutton -pady {1 0} -padx 2 -side left\n\
	pack $wf.top -padx 4 -fill both -expand true\n\
	grid $wf.center.fw -padx {2 0} -pady {0 2} -row 0 -column 0\n\
	grid $wf.center.rightbar -padx {1 0} -row 0 -column 1 -sticky ns\n\
	pack $wf.center.rightbar.bluecolumns.into -padx 2 -pady 2 -fill both -expand true\n\
	pack $wf.center.rightbar.bluecolumns -padx {1 2} -pady {2 1} -fill both -expand true\n\
	pack $wf.center.rightbar.resizebutton	\n\
	pack $wf.center\n\
\n\
	;# This is for the next window.\n\
	\n\
	incr WindowNumber\n\
\n\
}",
"proc ShouldManage {XId} {\n\
\n\
    	;# Don't try to manage the window manager's windows!\n\
    	\n\
    	if {[catch {xop window $XId inthisapp} inthisapp] || $inthisapp} {\n\
		return 0\n\
    	}\n\
\n\
    	;# Don't manage windows that have the overrideredirct flag set\n\
    	;# these are usually things like popup menus that should not\n\
    	;# have window manager decorations.\n\
\n\
    	array set atts [xop window $XId attributes]\n\
    	if {![info exists atts(overrideRedirect)] || $atts(overrideRedirect)} {\n\
		return 0\n\
    	}\n\
\n\
    	;# OK, do it!\n\
\n\
    	return 1\n\
\n\
}",
"proc HandleNewWindow {XId} {\n\
    	global WinInfo\n\
	\n\
    	;# Don't do anything for windows we're not supposed to manage.\n\
\n\
    	if {![ShouldManage $XId]} {\n\
		return\n\
    	}\n\
\n\
    	;# OK, we're supposed to manage this window; start by making\n\
    	;# a window-manager frame around it.\n\
\n\
    	set WinInfo($XId,Max) 0\n\
    	MakeFrameAround $XId\n\
\n\
    	;# Try to get informations about the window.\n\
\n\
	array set atts [xop window $XId attributes]\n\
	catch {array set normalhints [xop wmprops $XId normalhints]}\n\
\n\
    	;# Figure out what the window's position.\n\
	\n\
	set windowPosition {0 0}\n\
	catch {set windowPosition $atts(position)}\n\
    	if {[info exists normalhints(userPosition)]} {\n\
    		set windowPosition $normalhints(userPosition)\n\
    	} elseif {[info exists normalhints(progPosition)]} {\n\
    		set windowPosition $normalhints(progPosition)\n\
    	}\n\
    	set WinInfo($XId,XPos) [lindex $windowPosition 0]\n\
    	set WinInfo($XId,YPos) [lindex $windowPosition 1]\n\
	\n\
	;# Place the window.\n\
	\n\
	place $WinInfo($XId,Path) -x $WinInfo($XId,XPos) -y $WinInfo($XId,YPos)\n\
\n\
}",
"foreach winID [xop window [winfo id .rw] children] {\n\
	HandleNewWindow $winID\n\
}",
"bind .rw <MapRequest> {HandleNewWindow %i}",
(char *) NULL
};

/*
 *----------------------------------------------------------------------
 *
 * main --
 *
 *	This is the main program for the application.
 *
 * Results:
 *	None.
 *
 * Side effects:
 *	Whatever the application does.
 *
 *----------------------------------------------------------------------
 */

void
#ifdef _USING_PROTOTYPES_
main (int    argc,		/* Number of command-line arguments. */
      char **argv)		/* Values of command-line arguments. */
#else
main(argc, argv)
    int argc;			/* Number of command-line arguments. */
    char **argv;		/* Values of command-line arguments. */
#endif
{
    Tcl_Interp *interp;
    char **p = script;
    char *q, buffer[10];
    Tcl_DString data;
    Tcl_Channel inChannel, outChannel, errChannel;

    Tcl_FindExecutable(argv[0]);
    interp = Tcl_CreateInterp();

    q = Tcl_Merge(argc-1, argv+1);
    Tcl_SetVar(interp, "argv", q, TCL_GLOBAL_ONLY);
    ckfree(q);
    sprintf(buffer, "%d", argc-1);
    Tcl_SetVar(interp, "argc", buffer, TCL_GLOBAL_ONLY);
    Tcl_SetVar(interp, "argv0", argv[0],TCL_GLOBAL_ONLY);
    Tcl_SetVar(interp, "tcl_interactive","0", TCL_GLOBAL_ONLY);

    if (Tcl_Init(interp) != TCL_OK) {
        goto error;
    }
    if (Tk_Init(interp) != TCL_OK) {
        goto error;
    }
    Tcl_StaticPackage(interp, "Tk", Tk_Init, Tk_SafeInit);

    /*
     * Execute the script that is compiled in.
     */

    inChannel = Tcl_GetStdChannel(TCL_STDIN);
    outChannel = Tcl_GetStdChannel(TCL_STDOUT);
    Tcl_DStringInit(&data);
    while(*p) {
	Tcl_DStringSetLength(&data,0);
	Tcl_DStringAppend(&data,*p++,-1);
	if (Tcl_Eval(interp,Tcl_DStringValue(&data)) != TCL_OK) {
	    Tcl_DStringFree(&data);
	    while (p-- != script) {
		for (q = *p;*q; q++) {
		    if (*q=='\n') line++;
		}
		line++;
	    }
	    sprintf(buffer,"%d",line);
	    Tcl_AddErrorInfo(interp,"\n	( Error in file: \"");
	    Tcl_AddErrorInfo(interp,__FILE__);
	    Tcl_AddErrorInfo(interp,"\", line: ");
	    Tcl_AddErrorInfo(interp,buffer);
	    Tcl_AddErrorInfo(interp,")");
	    errChannel = Tcl_GetStdChannel(TCL_STDERR);
	    if (errChannel) {
		Tcl_Write(errChannel,
			Tcl_GetVar(interp, "errorInfo", TCL_GLOBAL_ONLY), -1);
		Tcl_Write(errChannel, "\n", 1);
	    }
	    sprintf(buffer, "exit %d", 1);
	    Tcl_Eval(interp, buffer);
	}
    }
    Tcl_DStringFree(&data);

    while (Tcl_DoOneEvent(0)) {
	/* empty loop body */ ;
    }
    sprintf(buffer, "exit %d", 0);
    Tcl_Eval(interp, buffer);

error:
    errChannel = Tcl_GetStdChannel(TCL_STDERR);
    if (errChannel) {
	Tcl_Write(errChannel,
		"application-specific initialization failed: ", -1);
	Tcl_Write(errChannel, interp->result, -1);
	Tcl_Write(errChannel, "\n", 1);
    }
    sprintf(buffer, "exit %d", 1);
    Tcl_Eval(interp, buffer);
}
