;############################################
;# RetroLook SVN - make your desktop retro' #
;############################################

;# Copyright (C) 2016 Pasquale Frega
;# All rights reserved

;# Based on TKWM 2.0 by Neil McKay and Peter
;# MacDonald

;# Released under the simplified BSD license

;# last edit: 04-Jun-2016

;# begin

;# Load the libraries.

load libRootwin0.4.so
load libXop0.4.so
load libForeignwin0.1.so

;# Set the main window.

wm withdraw .
update idletasks
rootwin .rw -background #1f54ac

;# The array WinInfo contains all the bookkeeping info
;# that we need for each managed window. The array indices
;# are of the form "XId,fieldName", where "XId" is the
;# X window identifier of the application's main window
;# and "fieldName" is a name that describes the information
;# stored. Valid values for "fieldName" are:
;#
;#	Path		Tk path name of the application's
;#			window manager decorations
;#
;#	XPos		X coordinate of the application's
;#			window decorations
;#
;#	YPos		Y coordinate of the application's
;#			window decorations
;#
;#	NWidth		Window width in "normal" state
;#
;#	NHeight		Window height in "normal" state
;#
;#	Max		1 if window is maximized, 0 if normal size
;#

array set WinInfo {}

;# Declare the other variables.

variable WindowMarkPos
variable WindowMarkSize
variable WindowNumber 0

;# Create the button bitmaps.

image create bitmap closeImage -data {
 #define close_width 18
 #define close_height 17
 static unsigned char close_bits[] = {
   0xfe, 0xff, 0x01, 0xfe, 0xff, 0x01, 0x06, 0x80, 0x01, 0x06, 0x80, 0x01,
   0x06, 0x80, 0x01, 0x06, 0x80, 0x01, 0x86, 0x87, 0x01, 0x86, 0x87, 0x01,
   0x86, 0x87, 0x01, 0x86, 0x87, 0x01, 0x06, 0x80, 0x01, 0x06, 0x80, 0x01,
   0x06, 0x80, 0x01, 0x06, 0x80, 0x01, 0xfe, 0xff, 0x01, 0xfe, 0xff, 0x01,
   0x00, 0x00, 0x00 };
}
image create bitmap maxImage -data {
 #define max_width 21
 #define max_height 17
 static unsigned char max_bits[] = {
   0xf0, 0xff, 0x0f, 0xf0, 0xff, 0x0f, 0xf0, 0x0f, 0x0c, 0xf0, 0x0f, 0x0c,
   0xf0, 0x0f, 0x0c, 0xf0, 0x0f, 0x0c, 0xf0, 0x0f, 0x0c, 0xf0, 0x0f, 0x0c,
   0x30, 0x00, 0x0c, 0x30, 0x00, 0x0c, 0x30, 0x00, 0x0c, 0x30, 0x00, 0x0c,
   0x30, 0x00, 0x0c, 0x30, 0x00, 0x0c, 0xf0, 0xff, 0x0f, 0xf0, 0xff, 0x0f,
   0x00, 0x00, 0x00 };
}
image create bitmap lowerImage -data {
 #define lower_width 18
 #define lower_height 17
 static unsigned char lower_bits[] = {
   0xfe, 0x1f, 0x00, 0xfe, 0x1f, 0x00, 0x06, 0x18, 0x00, 0x06, 0x18, 0x00,
   0x06, 0x18, 0x00, 0xc6, 0xff, 0x01, 0xc6, 0xff, 0x01, 0xc6, 0xff, 0x01,
   0xc6, 0xff, 0x01, 0xc6, 0xff, 0x01, 0xc6, 0xff, 0x01, 0xc6, 0xff, 0x01,
   0xfe, 0xff, 0x01, 0xfe, 0xff, 0x01, 0xc0, 0xff, 0x01, 0xc0, 0xff, 0x01,
   0x00, 0x00, 0x00 };
}
image create bitmap raiseImage -data {
 #define raise_width 18
 #define raise_height 17
 static unsigned char raise_bits[] = {
   0xfe, 0x1f, 0x00, 0xfe, 0x1f, 0x00, 0xfe, 0xff, 0x01, 0xfe, 0xff, 0x01,
   0x7e, 0x80, 0x01, 0x7e, 0x80, 0x01, 0x7e, 0x80, 0x01, 0x7e, 0x80, 0x01,
   0x7e, 0x80, 0x01, 0x7e, 0x80, 0x01, 0x7e, 0x80, 0x01, 0x7e, 0x80, 0x01,
   0x60, 0x80, 0x01, 0x60, 0x80, 0x01, 0xe0, 0xff, 0x01, 0xe0, 0xff, 0x01,
   0x00, 0x00, 0x00 };
}
image create bitmap resizeImage -data {
 #define resize_width 13
 #define resize_height 15
 static unsigned char resize_bits[] = {
   0x3f, 0x00, 0x3f, 0x00, 0x33, 0x00, 0x33, 0x00, 0xff, 0x0f, 0xff, 0x0f,
   0x30, 0x0c, 0x30, 0x0c, 0x30, 0x0c, 0x30, 0x0c, 0x30, 0x0c, 0x30, 0x0c,
   0xf0, 0x0f, 0xf0, 0x0f, 0x00, 0x00 };
}

;# Create the desktop topbar.

frame .rw.topbar -padx 6 -height 20 -background #fcfffb

;# Create the active tasks menu'.

menu .rw.tasks -borderwidth 2 -activeborderwidth 0 -relief flat -background #fcfffb -foreground #1f54ac -activebackground black -activeforeground #ff8a00 -tearoff 0

;# Popup active tasks menu'.

bind .rw <ButtonPress-3> {
	if {%i == [winfo id .rw] || %i == [winfo id .rw.topbar]} {
		tk_popup .rw.tasks %x %y
	}
}	

;# Show run form.

proc Run {} {
	variable to_run {}
	set run {
		catch {exec {*}$to_run &}
		wm withdraw .rw.run
	}

	if {![winfo exists .rw.run]} {
		toplevel .rw.run
		wm geometry .rw.run +90+50
		entry .rw.run.form -borderwidth 0 -highlightthickness 2 -highlightcolor #fcfffb -insertbackground #ff8a00 -background #1f54ac -foreground #fcfffb -selectbackground black -selectforeground #ff8a00 -width 60 -font {-size 9 -weight bold} -textvariable to_run
		bind .rw.run.form <Return> $run
		bind .rw.run.form <FocusOut> {wm withdraw .rw.run}
		
		pack .rw.run.form
	}
	
	wm deiconify .rw.run
	raise .rw.run
	focus -force .rw.run.form
}

;# Show about the author.

proc About {} {
	if {![winfo exists .rw.about]} {
		frame .rw.about -background #fcfffb
		frame .rw.about.into -pady 3 -background #1f54ac
		frame .rw.about.into.main -background #fcfffb
		frame .rw.about.into.main.border -background #1f54ac
		label .rw.about.into.main.border.message -background #fcfffb -foreground black -font {-size 9 -weight bold} -text "RetroLook 20160626\nCopyright (C) 2016 Pasquale Frega\nAll rights reserved\n\nBased on TKWM 2.0\nby Neil McKay\nand Peter MacDonald"
		frame .rw.about.into.button -background #ff8a00
		button .rw.about.into.button.ok -borderwidth 0 -background #fcfffb -activebackground #fcfffb -highlightbackground #fcfffb -foreground black -font {-size 9 -weight bold} -text {Ok} -command {place forget .rw.about}
		
		pack .rw.about.into.main.border.message -padx 2 -pady 2 -ipadx 19 -ipady 19
		pack .rw.about.into.main.border -padx 2 -pady 2
		pack .rw.about.into.main -padx 6 -pady 2
		pack .rw.about.into.button.ok -padx 2 -pady 2
		pack .rw.about.into.button -pady 2
		pack .rw.about.into -padx 2 -pady 2
	}

	place .rw.about -x 0 -y 0
	raise .rw.about
}

;# Show quit dialog.

proc Quit {} {
	if {![winfo exists .rw.quit]} {
		frame .rw.quit -background #fcfffb
		frame .rw.quit.into -pady 3 -background #1f54ac
		frame .rw.quit.into.main -background #fcfffb
		frame .rw.quit.into.main.border -background #1f54ac
		label .rw.quit.into.main.border.message -background #fcfffb -foreground black -font {-size 9 -weight bold} -text "Do you really want\nto quit workbench?"
		frame .rw.quit.into.buttons -background #1f54ac
		button .rw.quit.into.buttons.ok -borderwidth 0 -background #fcfffb -activebackground #fcfffb -highlightthickness 2 -highlightbackground #ff8a00 -foreground black -font {-size 9 -weight bold} -text {Ok} -command exit
		button .rw.quit.into.buttons.cancel -borderwidth 0 -background #fcfffb -activebackground #fcfffb -highlightthickness 2 -highlightbackground #ff8a00 -foreground black -font {-size 9 -weight bold} -text {Cancel} -command {place forget .rw.quit}
	
		pack .rw.quit.into.main.border.message -padx 2 -pady 2 -ipadx 19 -ipady 19
		pack .rw.quit.into.main.border -padx 2 -pady 2
		pack .rw.quit.into.main -padx 6 -pady 2
		pack .rw.quit.into.buttons.ok -padx 6 -ipady 1 -side left
		pack .rw.quit.into.buttons.cancel -padx 6 -ipady 1 -side right
		pack .rw.quit.into.buttons -pady 2 -expand true -fill both
		pack .rw.quit.into -padx 2 -pady 2
	}
	
	place .rw.quit -x 0 -y 0
	raise .rw.quit
}

;# Create the menu' from "~/.retrolookmenu".

if {[file exists ~/.retrolookmenu]} {
	if {![catch {open ~/.retrolookmenu} chid]} {
		menubutton .rw.topbar.workbench -borderwidth 0 -background #fcfffb -foreground #1f54ac -activebackground black -activeforeground #ff8a00 -font {-size 9 -weight bold} -text {Workbench} -menu .rw.topbar.workbench.menu
		menu .rw.topbar.workbench.menu -borderwidth 2 -activeborderwidth 0 -relief flat -background #fcfffb -foreground #1f54ac -activebackground black -activeforeground #ff8a00 -tearoff 0
		while {![string equal [set got_string [gets $chid]] {}]} {
			.rw.topbar.workbench.menu add command -font {-size 9 -weight bold} -label [lindex $got_string 0] -command "catch {exec [lindex $got_string 1] &}"
		}
		close $chid
		.rw.topbar.workbench.menu add separator
		.rw.topbar.workbench.menu add command -font {-size 9 -weight bold} -label {Run...} -command Run
		.rw.topbar.workbench.menu add command -font {-size 9 -weight bold} -label {About} -command About
		.rw.topbar.workbench.menu add command -font {-size 9 -weight bold} -label {Quit} -command Quit
	} else {
		tk_messageBox -icon error -message {ERROR}
		exit 1
	}
} else {
	tk_messageBox -icon warning -message {Need ~/.retrolookmenu}
	exit 1
}

;# Create the stack buttons and pack everything.

button .rw.topbar.lowerbutton -borderwidth 0 -highlightthickness 0 -background #fcfffb -activebackground #fcfffb -image lowerImage -command {lower .rw.topbar}
button .rw.topbar.raisebutton -borderwidth 0 -highlightthickness 0 -background #fcfffb -activebackground #fcfffb -image raiseImage -command {raise .rw.topbar}
pack propagate .rw.topbar false
pack .rw.topbar.workbench -padx 20 -side left
pack .rw.topbar.raisebutton -pady {1 0} -side right
pack .rw.topbar.lowerbutton -pady {1 0} -padx 2 -side right
pack .rw.topbar -fill x

;# Create two fake icons on the desktop if there is present the Img package.

if {![catch {package require img::xpm}]} {
	image create photo ramdisk -data {/* XPM */
static char * ramdisk_xpm[] = {
"32 32 4 1",
"       c #000021",
".      c #0055AD",
"+      c #FFFFFF",
"@      c #FF8A00",
"                          ......",
"                          ......",
"  ++++++@@@@@@    @@@@++    ....",
"  ++++++@@@@@@    @@@@++    ....",
"  ++++++@@@@@@    @@@@++++    ..",
"  ++++++@@@@@@    @@@@++++    ..",
"  ++++++@@@@@@    @@@@++++++    ",
"  ++++++@@@@@@    @@@@++++++    ",
"  ++++++@@@@@@    @@@@++++++++  ",
"  ++++++@@@@@@    @@@@++++++++  ",
"  ++++++@@@@@@@@@@@@@@++++++++  ",
"  ++++++@@@@@@@@@@@@@@++++++++  ",
"  ++++++++++++++++++++++++++++  ",
"  ++++++++++++++++++++++++++++  ",
"  ++++++++++++++++++++++++++++  ",
"  ++++++++++++++++++++++++++++  ",
"  ++++++++++++++++++++++++++++  ",
"  ++++++++++++++++++++++++++++  ",
"  ++++++++++++++++++++++++++++  ",
"  ++++++++++++++++++++++++++++  ",
"  ++++++++++++++++++++++++++++  ",
"  ++++++++++++++++++++++++++++  ",
"  ++++++++++++++++++++++++++++  ",
"  ++++++++++++++++++++++++++++  ",
"  ++++++++++++++++++++++++++++  ",
"  ++++++++++++++++++++++++++++  ",
"  ++++++++++++++++++++++++++++  ",
"  ++++++++++++++++++++++++++++  ",
"  ++++++++++++++++++++++++++++  ",
"  ++++++++++++++++++++++++++++  ",
"                                ",
"                                "};
	}
	image create photo workbench -data {/* XPM */
static char * workbench_xpm[] = {
"35 30 5 1",
"       c #000021",
".      c #FF8A00",
"+      c #0055AD",
"@      c #FFFFFF",
"#      c #000000",
"         .................       ++",
"         .................       ++",
"         ..........    ...        +",
"         ..........    ...        +",
"         ..........    ...         ",
"         ..........    ...         ",
"         ..........    ...         ",
"         ..........    ...         ",
"         .................         ",
"         .................         ",
"                                   ",
"                                   ",
"                                   ",
"                                   ",
"      @@@@@@@@@@@@@@@@@@@@@@       ",
"      @@@@@@@@@@@@@@@@@@@@@@       ",
"      @@@@@@@@@@@@@@@@@@@@@@@      ",
"      @@@@@@@@@@@@@@@@@@@@@@@      ",
"      @@@@@@@@@@@@@@@@@@@@@@@      ",
"      @#@#@@@#@#@@@#@#@@@#@#@      ",
"      @@#@#@@@#@#@#@#@@@#@#@@      ",
"      @@@#@#@@@#@#@#@@@#@#@@@      ",
"      @@@@#@#@@@#@#@@@#@#@@@@      ",
"      @@@@@#@#@#@#@#@#@#@@@@@      ",
"      @@@@@@#@#@#@#@#@#@@@@@@      ",
"      @@@@@@@#@#@@@#@#@@@@@@@      ",
"  ++  @@@@@@@@@@@@@@@@@@@@@@@      ",
"  ++  @@@@@@@@@@@@@@@@@@@@@@@      ",
"      @@@@@@@@@@@@@@@@@@@@@@@      ",
"      @@@@@@@@@@@@@@@@@@@@@@@      "};
	}

	label .rw.ramdisk -borderwidth 0 -background #1f54ac -foreground #fcfffb -image ramdisk -compound top -font {-size 9 -weight bold} -text {RAM DISK}
	label .rw.workbench -borderwidth 0 -background #1f54ac -foreground #fcfffb -image workbench -compound top -font {-size 9 -weight bold} -text {Workbench1.4}

	place .rw.ramdisk -x 17 -y 33
	place .rw.workbench -x 0 -y 89
}

;# CleanupFor cleans up all the records associated with
;# window "XId".

proc CleanupFor {XId WindowNumber} {
	global WinInfo

	foreach idx [array names WinInfo "$XId,*"] {
		unset WinInfo($idx)
	}
	for {set idx 0} {$idx <= $WindowNumber} {incr idx} {
		if {[.rw.tasks entrycget $idx -value] == $WindowNumber} {
			.rw.tasks delete $idx
			break
		}
	} 
}

;# Close the window.
    	
proc CloseWindow {XId wf} {
	xop event send $XId ClientMessage -messagetype [winfo atom WM_PROTOCOLS] -format 32 -data "[winfo atom WM_DELETE_WINDOW] 0"
	destroy $wf.center.fw
}

;# Check map state after receiving an expose event. If
;# unmapped and does not seem to show video, destroy the 
;# application frame.

proc CheckMapState {XId wf} {
	catch {array set atts [xop window $XId attributes]}
	
	if {[info exists atts(mapInstalled)] && $atts(mapInstalled) && [info exists atts(mapState)] && [string equal $atts(mapState) {unmapped}]} {
		destroy $wf.center.fw
	}
}

;# Raise and focus the window.

proc MarkAndRaise {w XId x y} {
    	global WindowMarkPos

    	raise $w
    	set WindowMarkPos($w,x) $x
    	set WindowMarkPos($w,y) $y
	
	xop focus "$XId None"
}

;# Move the window only if not maximized.

proc Move {w XId x y} {
    	global WindowMarkPos
    	global WinInfo

	if {$WinInfo($XId,Max) == 0} {
		set offsetX [expr {$x - $WindowMarkPos($w,x) + $WinInfo($XId,XPos)}]
    		set offsetY [expr {$y - $WindowMarkPos($w,y) + $WinInfo($XId,YPos)}]
    		place $w -x $offsetX -y $offsetY

    		set WinInfo($XId,XPos) $offsetX
    		set WinInfo($XId,YPos) $offsetY

    		set WindowMarkPos($w,x) $x
    		set WindowMarkPos($w,y) $y
    	}
}

;# Toggle the "maximized" state of the window.

proc MaxMinWindow {XId} {
    	global WinInfo

	set w $WinInfo($XId,Path)
    	if {$WinInfo($XId,Max)} {
	
		;# Restore original window size.

		$w.center.fw configure -width $WinInfo($XId,NWidth) -height $WinInfo($XId,NHeight)
		place $w -x $WinInfo($XId,XPos) -y $WinInfo($XId,YPos)
		set WinInfo($XId,Max) 0
    
    	} else {
	
		;# Maximize window. First, figure out how big it should be.

		set widthDiff [expr {[winfo width $w] - [winfo width $w.center.fw]}]
		set heightDiff [expr {[winfo height $w] - [winfo height $w.center.fw]}]
		set maxWidth [expr {[winfo width .rw] - $widthDiff}]
		set maxHeight [expr {[winfo height .rw] - $heightDiff - 20}]

		;# Now resize the window, and put it in the upper left corner.

		$w.center.fw configure -width $maxWidth -height $maxHeight
		place $w -x 0 -y 20
		set WinInfo($XId,Max) 1
    	
    	}
}

;# MarkSpot marks a spot (x,y) for window w. It also records
;# the window's current size and position for resizing purposes.

proc MarkSpot {w XId x y} {
	global WindowMarkPos
    	global WindowMarkSize

    	set WindowMarkPos($w,X) $x
    	set WindowMarkPos($w,Y) $y
    	set WindowMarkSize($w,Width) [winfo width $w.center.fw]
    	set WindowMarkSize($w,Height) [winfo height $w.center.fw]
}

;# ResizeWin resizes window w (corresponding to X window ID XId).
;# It does so by finding the change between the position (x,y)
;# and the previously marked position; these changes are then
;# multiplied by xSizeMult and ySizeMult, and added to the recorded
;# window size, giving the new window size. The window's position
;# is then offset by an amount corresponding to the changes
;# multiplied by xOffsetMult and yOffsetMult.

proc ResizeWin {w XId xSizeMult x xOffsetMult ySizeMult y yOffsetMult} {
    	global WinInfo
    	global WindowMarkPos
    	global WindowMarkSize

    	set deltaX [expr {$x - $WindowMarkPos($w,X)}]
    	set deltaY [expr {$y - $WindowMarkPos($w,Y)}]

    	set NewWindowWidth [expr {$WindowMarkSize($w,Width) + $xSizeMult*$deltaX}]
    	set NewWindowHeight [expr {$WindowMarkSize($w,Height) + $ySizeMult*$deltaY}]
    	$w.center.fw configure -width $NewWindowWidth -height $NewWindowHeight
    	if {!$WinInfo($XId,Max)} {
		set WinInfo($XId,NWidth) $NewWindowWidth
		set WinInfo($XId,NHeight) $NewWindowHeight
    	}
}

;# MakeFrameAround builds a frame around window "XId".

proc MakeFrameAround {XId} {
	global WinInfo
	global WindowNumber
	variable Title {X}
    	
	;# Make sure we don't do this twice.

    	if {[info exists WinInfo($XId,Path)]} {
    		return
    	}
    	
    	;# Try to get informations about the window.

	array set atts [xop window $XId attributes]
	catch {set Title [xop wmprops $XId name]}
	catch {array set normalhints [xop wmprops $XId normalhints]}

    	;# Make a frame in the root window to hold the managed window.

    	set wf ".rw.frame$WindowNumber"
    	frame $wf -background #fcfffb
    	set WinInfo($XId,Path) $wf

    	;# Make the title bar at the top.

    	frame $wf.top -height 20 -background #fcfffb
    	button $wf.top.closebutton -borderwidth 0 -highlightthickness 0 -background #fcfffb -activebackground #fcfffb -image closeImage -command [list CloseWindow $XId $wf]
    	label  $wf.top.title -background #fcfffb -foreground #1f54ac -font {-size 9 -weight bold} -text $Title
    	frame $wf.top.bluerows -background #1f54ac
    	frame $wf.top.bluerows.into -background #fcfffb
    	button $wf.top.maxbutton -borderwidth 0 -highlightthickness 0 -background #fcfffb -activebackground #fcfffb -image maxImage -command [list MaxMinWindow $XId]
    	button $wf.top.lowerbutton -borderwidth 0 -highlightthickness 0 -background #fcfffb -activebackground #fcfffb -image lowerImage -command "catch {lower $wf; lower .rw.ramdisk; lower .rw.workbench}"
    	button $wf.top.raisebutton -borderwidth 0 -highlightthickness 0 -background #fcfffb -activebackground #fcfffb -image raiseImage -command [list MarkAndRaise $wf $XId %X %Y]

	;# Make the center frame.
	
	frame $wf.center -background #fcfffb

    	;# Get window width/height and create the application frame.

	set winWidth 1
	set winHeight 1
	catch {set winWidth [lindex $atts(size) 0]}
	catch {set winHeight [lindex $atts(size) 1]}
    	if {[info exists normalhints(userSize)]} {
		set winWidth [lindex $normalhints(userSize) 0]
		set winHeight [lindex $normalhints(userSize) 1]
	} elseif {[info exists normalhints(progSize)]} {
		set winWidth [lindex $normalhints(progSize) 0]
		set winHeight [lindex $normalhints(progSize) 1]
    	} else {
    		if {$winWidth == 1} {
			set winWidth 512
		}
		if {$winHeight == 1} {
			set winHeight 384
		}
    	}
    	set WinInfo($XId,NWidth) $winWidth
    	set WinInfo($XId,NHeight) $winHeight
    	if {[catch {foreignwin $wf.center.fw $XId -width $winWidth -height $winHeight} FW]} {
		return
    	}
	
	;# Make the right bar and the resize button.
	
	frame $wf.center.rightbar -background #fcfffb
	frame $wf.center.rightbar.bluecolumns -background #1f54ac
	frame $wf.center.rightbar.bluecolumns.into -background #fcfffb
	button $wf.center.rightbar.resizebutton -borderwidth 0 -highlightthickness 0 -background #fcfffb -activebackground #fcfffb -image resizeImage

	;# Add item into the active tasks menu'.
	
	.rw.tasks add radiobutton -indicatoron false -font {-size 9 -weight bold} -label [string range $Title 0 19] -command "$wf.top.raisebutton invoke" -value $WindowNumber
	
    	;# Bind stuff so that we can move/resize/etc...

	bind $wf <Map> "tkwait visibility $wf.center.fw; $wf.top.raisebutton invoke"
	foreach topwidget [list $wf.top $wf.top.title $wf.top.bluerows $wf.top.bluerows.into] {
		bind $topwidget <ButtonPress-1> [list MarkAndRaise $wf $XId %X %Y]
		bind $topwidget <Button1-Motion> [list catch [list Move $wf $XId %X %Y]]
	}
	foreach rightwidget [list $wf.center.rightbar $wf.center.rightbar.bluecolumns $wf.center.rightbar.bluecolumns.into] {
		bind $rightwidget <ButtonPress-1> [list MarkAndRaise $wf $XId %X %Y]
	}
	bind $wf.center.rightbar.resizebutton <ButtonPress-1> [list MarkSpot $wf $XId %X %Y]
	bind $wf.center.rightbar.resizebutton <Button1-Motion> [list ResizeWin $wf $XId 1 %X 0 1 %Y 0]
    	bind $wf <Enter> [list catch [list xop focus "$XId None"]]
	bind $FW <Expose> [list CheckMapState $XId $wf]
	
	;# We always forget the window frame and never destroy it.
	;# Why? Because it crashes!
	
	bind $FW <Destroy> "place forget $wf; CleanupFor $XId $WindowNumber"

	;# Pack everything.
	
	pack propagate $wf.top false
	pack $wf.top.closebutton -padx 2 -pady {1 0} -side left
	pack $wf.top.title -padx 1 -side left
	pack $wf.top.bluerows.into -pady 4 -fill both -expand true
	pack $wf.top.bluerows -padx 1 -pady 4 -side left -fill both -expand true
	pack $wf.top.maxbutton -padx 2 -pady {1 0} -side left
	pack $wf.top.lowerbutton -pady {1 0} -side left
	pack $wf.top.raisebutton -pady {1 0} -padx 2 -side left
	pack $wf.top -padx 4 -fill both -expand true
	grid $wf.center.fw -padx {2 0} -pady {0 2} -row 0 -column 0
	grid $wf.center.rightbar -padx {1 0} -row 0 -column 1 -sticky ns
	pack $wf.center.rightbar.bluecolumns.into -padx 2 -pady 2 -fill both -expand true
	pack $wf.center.rightbar.bluecolumns -padx {1 2} -pady {2 1} -fill both -expand true
	pack $wf.center.rightbar.resizebutton;	
	pack $wf.center

	;# This is for the next window.
	
	incr WindowNumber

}

;# "ShouldManage" returns 1 if XId is the X window ID of a
;# window that should be managed, 0 if it should not be
;# managed.

proc ShouldManage {XId} {

    	;# Don't try to manage the window manager's windows!
    	
    	if {[catch {xop window $XId inthisapp} inthisapp] || $inthisapp} {
		return 0
    	}

    	;# Don't manage windows that have the overrideredirct flag set
    	;# these are usually things like popup menus that should not
    	;# have window manager decorations.

    	array set atts [xop window $XId attributes]
    	if {![info exists atts(overrideRedirect)] || $atts(overrideRedirect)} {
		return 0
    	}

    	;# OK, do it!

    	return 1

}

;# HandleNewWindow does whatever needs to be done for
;# a newly-created window.

proc HandleNewWindow {XId} {
    	global WinInfo
	
    	;# Don't do anything for windows we're not supposed to manage.

    	if {![ShouldManage $XId]} {
		return
    	}

    	;# OK, we're supposed to manage this window; start by making
    	;# a window-manager frame around it.

    	set WinInfo($XId,Max) 0
    	MakeFrameAround $XId

    	;# Try to get informations about the window.

	array set atts [xop window $XId attributes]
	catch {array set normalhints [xop wmprops $XId normalhints]}

    	;# Figure out what the window's position.
	
	set windowPosition {0 0}
	catch {set windowPosition $atts(position)}
    	if {[info exists normalhints(userPosition)]} {
    		set windowPosition $normalhints(userPosition)
    	} elseif {[info exists normalhints(progPosition)]} {
    		set windowPosition $normalhints(progPosition)
    	}
    	set WinInfo($XId,XPos) [lindex $windowPosition 0]
    	set WinInfo($XId,YPos) [lindex $windowPosition 1]
	
	;# Place the window.
	
	place $WinInfo($XId,Path) -x $WinInfo($XId,XPos) -y $WinInfo($XId,YPos)

}

;# Here's the guts of the window manager. First, we make
;# a frame around each existing window. Then we handle
;# MapRequest events, so that we can put a frame around
;# each newly-created window.

foreach winID [xop window [winfo id .rw] children] {
	HandleNewWindow $winID
}

;# Is your computer very old? Try this:
;# bind .rw <MapRequest> {after 100 [list HandleNewWindow %i]}

bind .rw <MapRequest> {HandleNewWindow %i}

;# end
